﻿#include "testlib.h"
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>
#include <set>
#include <utility>

using namespace std;

int count_harvest(vector <int>& a, vector <int>& b, vector <int>& v) {
    int harvest = 0;
    for (int i = 0; i < v.size(); i++) {
        harvest += a[v[i]];
    }
    return harvest;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int t;
    t = inf.readInt();
    long double score = 0;
    for (int testcase = 0; testcase < t; ++testcase) {
        int n = inf.readInt();
        vector <int> a(n + 1);
        vector <int> b(n + 1);

        for (int i = 1; i <= n; ++i) {
            a[i] = inf.readInt();
        }
        for (int i = 1; i <= n; ++i) {
            b[i] = inf.readInt();
        }
        int n_p = ouf.readInt();
        vector <int> out_p(n_p);
        int sum_a = 0, sum_b = 0;
        vector<bool> used(n + 1, false);
        for (int i = 0; i < n_p; ++i) {
            out_p[i] = ouf.readInt();
            if (out_p[i] > n || out_p[i] < 1) {
                quitf(_wa, "Deprecated number in testcase %d: %d", testcase, out_p[i]);
            }
            if (used[out_p[i]]) {
                quitf(_wa, "Doubly number in testcase %d: %d", testcase, out_p[i]);
            }
            used[out_p[i]] = true;
            sum_a += a[out_p[i]];
            sum_b += b[out_p[i]];
        }
        if (sum_a != sum_b) {
            quitf(_wa, "Sum in a not equal sum in b %d: %d", sum_a, sum_b);
        }

        int n_j = ans.readInt();
        vector <int> ans_j(n_j);
        for (int i = 0; i < n_j; ++i) {
            ans_j[i] = ans.readInt();
        }

        int pa = count_harvest(a, b, out_p);
        int ja = count_harvest(a, b, ans_j);

        /*if (pa < ja) {
            quitf(_fail, "Particiapnt found better solution at testcase %d", testcase);
        }*/
        long double mul = 1.0;
        int deg = 10;
        for (int _ = 0; _ < deg; _++) {
            mul *= (1.0 * pa) / ja;
        }
        score += 10.0 * mul;
    }
    quitp(score, "participant's solution is ok");
    return 0;
}
