#include "testlib.h"
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>
#include <set>
#include <map>

using namespace std;

int main(int argc, char* argv[]) {
	registerTestlibCmd(argc, argv);
	int score = 0;
	int t = inf.readInt();
	for (int testno = 0; testno < t; ++testno) {
		bool flag = true;
		string txt = inf.readWord();
		string enc = inf.readWord();
		set <string> used_chars;

		for (auto c : txt) {
			string tmpc = "";
			tmpc += c;
			used_chars.insert(tmpc);
		}
		int symcnt = used_chars.size();
		map <string, string> dct;
		for (int i = 0; i < used_chars.size(); ++i) {
			string sym = ouf.readWord();
			string code = ouf.readWord();
			if (sym.size() > 1) {
				flag = false;
				//quitf(_wa, "Should be one symbol in test %d, line %d", testno, i);
			}
			if (used_chars.find(sym) == used_chars.end()) {
				flag = false;
				//quitf(_wa, "Wrong symbol in test %d, line %d", testno, i);
			}
			for (auto c : code) {
				if (c != '0' && c != '1') {
					flag = false;
					//quitf(_wa, "Wrong symbol (not 0 or 1) in test %d, line %d", testno, i);
				}
			}
			if (code.size() > enc.size()) {
				flag = false;
				//quitf(_wa, "Code too long in test %d, line %d", testno, i);
			}
			dct[sym] = code;
		}
		for (char c1 = 'a'; c1 <= 'z'; ++c1) {
			string sc1 = "";
			sc1 += c1;
			if (dct.find(sc1) == dct.end()) continue;
			for (char c2 = 'a'; c2 <= 'z'; ++c2) {
				string sc2 = "";
				sc2 += c2;
				if (dct.find(sc2) == dct.end()) continue;
				if (c1 == c2) continue;
				if (dct[sc1] == dct[sc2].substr(0, dct[sc1].size())) {
					flag = false;
					//quitf(_wa, "Code is not prefix free test %d", testno);
				}
			}
		}
		string enc2 = "";
		for (auto c : txt) {
			string sc = "";
			sc += c;
			if (dct.find(sc) == dct.end()) {
				flag = false;
				//quitf(_wa, "No code for symbol test %d", testno);
			}
			enc2 += dct[sc];
		}
		if (enc != enc2) {
			flag = false;
			//quitf(_wa, "Wrong decoding %d", testno);
		}
		if (flag) score += 10;

	}

	quitp(score, "participant's solution is ok");
	return 0;
}